package edu.cmu.paid.network.test;
 
import edu.cmu.paid.network.*; 
import edu.cmu.paid.network.voyager.*; 
import edu.cmu.paid.network.exception.*; 
import edu.cmu.paid.authentication.*;
import edu.cmu.paid.authentication.util.*;
import java.lang.String; 
 
 
/** 
 * Program which instatiates all subsystem objects
 * on COMET server.
 *  
 * @author Will Ross 
 */  
 
public class RunComet { 
 
  /** 
   * Creates objects for various subsystems and
   * exports them as necessary.
   */ 
  public static void main(String[] args) { 
 
    String net_server_port = ""; 
    String net_server_name = ""; 
    CServer myNetServer = null; 
    IServer exported_net_server = null; 
 
    AuthServer myAuthServer = null; 
    Authentication_Interface exported_auth_server = null; 
    String auth_server_name = "1235/AUTH_SERVER"; 
 
 
    //get port number to use 
    if(args.length == 1) 
      net_server_port = args[0]; 
    else 
      net_server_port = "9000"; 
 
    net_server_name = new String(net_server_port + "/NET_SERVER"); 
 




  
    //Start voyager 
    try { 
      RemoteObjectManager.startup(); 
      RemoteObjectManager.startup("7243");
    } catch(Exception e) { System.err.println("* RunServer: voyager startup failed."); } 
 
 
 

 

    /***************
      *  LEARNING  *
      ***************/
 

    //Start a LearningController object.
    //This is passed to the Db object and used by them.
    //It is not exported.
    LearningController lc = new LearningController();
    




   /********************
     *  Event Service  *
     ********************/

    EventService es = new EventService("COMET");





    /**************
      *  NETWORK  *
      **************/


    //create a new CServer object 
    myNetServer = new CServer( ); 
 
    //export the CServer to specified port and get a proxy to it 
    try { 
      exported_net_server = (IServer) RemoteObjectManager.export( myNetServer, net_server_port ); 
    } catch(Exception e) {  
      System.err.println("* RunServer: Unable to export CServer object."); 
      System.exit(0); 
    } 
       
    //Bind a name to the exported CServer 
    try { 
      RemoteObjectManager.bind(net_server_name, exported_net_server); 
    } catch(Exception e) { 
      System.err.println("* RunServer: Name binding error:" + e); 
      system.exit(0);
    } 
    



    /*********************
      *  AUTHENTICATION  *      - this does not run on the COMET server.
      *********************/
/*
    
    //   create a new Authentication object
    myAuthServer = new edu.cmu.paid.authentication.AuthServer(); 
    
    if (myAuthServer==null){ 
	System.out.println("The authentication object is null"); 
    }
 
    //export myAuthServer to port 1235 and get a proxy to it 
    try { 
      exported_auth_server = (Authentication_Interface) RemoteObjectManager.export( myAuthServer, "1235" ); 
    } catch(Exception e) { System.err.println("* ServerThread: unable to export AuthServer:" + e.toString()); } 
   
    // name exported_auth_server.. 
    try { 
      RemoteObjectManager.bind(auth_server_name, exported_auth_server); 
    } catch(Exception e) { System.err.println("* ServerThread: Name binding error:" + e); } 
 

*/




    //now we just sit and serve. 
    System.out.println("Server running on port " + net_server_port); 
     
  } 
} 
